import { defineStore } from "pinia";
import { http } from "@/serverCom";
import type { InspectionPlanViewModel } from "@/viewmodels/admin/unit/inspection/inspectionPlan.models";
import { useWearableTypeStore } from "./wearableType";

export const useWearableTypeInspectionPlanStore = defineStore("wearableTypeInspectionPlan", {
  state: () => {
    return {
      inspectionPlans: [] as Array<InspectionPlanViewModel>,
      totalCount: 0 as number,
      loading: "loading" as "loading" | "fetched" | "failed",
    };
  },
  actions: {
    fetchInspectionPlanForWearableType() {
      const wearableTypeId = useWearableTypeStore().activeWearableType;
      this.loading = "loading";
      http
        .get(`/admin/inspectionPlan/wearableType/${wearableTypeId}?noLimit=true`)
        .then((result) => {
          this.inspectionPlans = result.data.inspectionPlans;
          this.loading = "fetched";
        })
        .catch((err) => {
          this.loading = "failed";
        });
    },
  },
});
