import type { EquipmentViewModel } from "./equipment/equipment.models";
import type { RepairViewModel } from "./repair.models";
import type { VehicleViewModel } from "./vehicle/vehicle.models";
import type { WearableViewModel } from "./wearable/wearable.models";

export type DamageReportAssigned = {
  relatedId: string;
} & (
  | {
      assigned: "equipment";
      related: EquipmentViewModel;
    }
  | {
      assigned: "vehicle";
      related: VehicleViewModel;
    }
  | {
      assigned: "wearable";
      related: WearableViewModel;
    }
);

export type DamageReportViewModel = {
  id: string;
  title: string;
  reportedAt: Date;
  closedAt?: Date;
  closedBy?: string;
  status: string;
  description: string;
  location: string;
  noteByReporter: string;
  noteByWorker: string;
  images: string[];
  reportedBy: string;
  repair?: RepairViewModel;
} & Optional<DamageReportAssigned>;

export interface CreateDamageReportViewModel {
  title: string;
  description: string;
  reportedBy: string;
  affectedId: string;
  affected: "equipment" | "vehicle" | "wearable";
}

export interface UpdateDamageReportViewModel {
  id: string;
  status: string;
  noteByWorker: string;
  done: boolean;
}
