import type { EquipmentViewModel } from "./equipment/equipment.models";
import type { VehicleViewModel } from "./vehicle/vehicle.models";
import type { WearableViewModel } from "./wearable/wearable.models";

export type MaintenanceAssigned = {
  relatedId: string;
} & (
  | {
      assigned: "equipment";
      related: EquipmentViewModel;
    }
  | {
      assigned: "vehicle";
      related: VehicleViewModel;
    }
  | {
      assigned: "wearable";
      related: WearableViewModel;
    }
);

export type MaintenanceViewModel = {
  id: string;
  createdAt: Date;
  status: string;
  description: string;
} & MaintenanceAssigned;

export interface CreateMaintenanceViewModel {
  description: string;
  reportedBy: string;
  affectedId: string;
  affected: "equipment" | "vehicle" | "wearable";
}

export interface UpdateMaintenanceViewModel {
  id: string;
  status: string;
  done: boolean;
}
