import type { MemberViewModel } from "@/viewmodels/admin/club/member/member.models";
import type { WearableTypeViewModel } from "./wearableType.models";

export interface WearableViewModel {
  id: string;
  code?: string;
  name: string;
  location: string;
  commissioned: Date;
  decommissioned?: Date;
  wearerId?: string;
  wearer?: MemberViewModel;
  wearableTypeId: string;
  wearableType: WearableTypeViewModel;
}

export interface MinifiedWearableViewModel {
  id: string;
  code?: string;
  name: string;
  type: string;
  assigned: "wearable";
}

export interface CreateWearableViewModel {
  code?: string;
  name: string;
  wearerId?: string;
  location?: string;
  commissioned: Date;
  wearableTypeId: string;
}

export interface UpdateWearableViewModel {
  id: string;
  code?: string;
  name: string;
  location?: string;
  commissioned: Date;
  decommissioned?: Date;
  wearerId?: string;
}
